function createState(initialState) {
    var subscribers = [];
    return {
        state: initialState,
        subscribers: subscribers,
        setState: function (getState) {
            var _this = this;
            this.state = Object.assign({}, this.state, typeof getState === "function" ? getState(this.state) : getState);
            return Promise.all(this.subscribers.map(function (sub) { return sub(_this.state); }));
        },
        subscribe: function (fn) {
            this.subscribers.push(fn);
        },
        unsubscribe: function (fn) {
            this.subscribers = this.subscribers.filter(function (f) {
                return f !== fn;
            });
        },
    };
}

export default createState;
//# sourceMappingURL=index.es.js.map
